Package net.sf.saxon.expr

## Class Literal

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.Literal

- All Implemented Interfaces:
    `ExportAgent`, `Locatable`, `IdentityComparable`, `Traceable`
  Direct Known Subclasses:
    `FunctionLiteral`, `StringLiteral`

      public class Literal
      extends Expression

  A Literal is an expression whose value is constant: it is a class that implements the `Expression` interface as a wrapper around a `GroundedValue`. This may derive from an actual literal in an XPath expression or query, or it may be the result of evaluating a constant subexpression such as true() or xs:date('2007-01-16')

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, ITEM_FEED_METHOD, ITERATE_METHOD, MAX_COST, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, PROCESS_METHOD, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, UPDATE_METHOD, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `protected` | `Literal​(GroundedValue value)` | Create a literal as a wrapper around a Value

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `PathMap.PathMapNodeSet` | `addToPathMap​(PathMap pathMap, PathMap.PathMapNodeSet pathMapNodeSet)` | Add a representation of this expression to a PathMap.
    `int` | `computeCardinality()` | Determine the cardinality
    `int` | `computeHashCode()` | Return a hash code to support the equals() function
    `int` | `computeSpecialProperties()` | Compute the static properties of this expression (other than its type).
    `Expression` | `copy​(RebindingMap rebindings)` | Copy an expression.
    `boolean` | `effectiveBooleanValue​(XPathContext context)` | Get the effective boolean value of the expression.
    `boolean` | `equals​(java.lang.Object obj)` | Determine whether two literals are equal, when considered as expressions.
    `java.lang.CharSequence` | `evaluateAsString​(XPathContext context)` | Evaluate an expression as a String.
    `Item` | `evaluateItem​(XPathContext context)` | Evaluate as a singleton item (or empty sequence).
    `void` | `evaluatePendingUpdates​(XPathContext context, PendingUpdateList pul)` | Evaluate an updating expression, adding the results to a Pending Update List.
    `void` | `export​(ExpressionPresenter out)` | Diagnostic print of expression structure.
    `static void` | `exportAtomicValue​(AtomicValue value, ExpressionPresenter out)` |
    `static void` | `exportValue​(Sequence value, ExpressionPresenter out)` |
    `int` | `getDependencies()` | Determine which aspects of the context the expression depends on.
    `java.lang.String` | `getExpressionName()` | Get a name identifying the kind of expression, in terms meaningful to a user.
    `int` | `getImplementationMethod()` | An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process().
    `IntegerValue[]` | `getIntegerBounds()` | For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis.
    `ItemType` | `getItemType()` | Determine the data type of the items in the expression, if possible
    `int` | `getNetCost()` | Return the estimated cost of evaluating an expression.
    `UType` | `getStaticUType​(UType contextItemType)` | Get the static type of the expression as a UType, following precisely the type inference rules defined in the XSLT 3.0 specification.
    `java.lang.String` | `getStreamerName()` | Get the (partial) name of a class that supports streaming of this kind of expression
    `GroundedValue` | `getValue()` | Get the value represented by this Literal
    `static boolean` | `hasEffectiveBooleanValue​(Expression exp, boolean value)` | Test if a literal has the effective boolean value true (or false)
    `static boolean` | `isAtomic​(Expression exp)` | Test whether the literal wraps an atomic value.
    `static boolean` | `isConstantBoolean​(Expression exp, boolean value)` | Test if a literal represents the boolean value true
    `static boolean` | `isConstantOne​(Expression exp)` | Test if a literal represents the integer value 1
    `static boolean` | `isEmptySequence​(Expression exp)` | Test whether the literal explicitly wraps an empty sequence.
    `boolean` | `isSubtreeExpression()` | Determine whether the expression can be evaluated without reference to the part of the context document outside the subtree rooted at the context node.
    `boolean` | `isVacuousExpression()` | Determine whether this is a vacuous expression as defined in the XQuery update specification
    `SequenceIterator` | `iterate()` | Return an Iterator to iterate over the values of a sequence.
    `SequenceIterator` | `iterate​(XPathContext context)` | Return an Iterator to iterate over the values of a sequence.
    `static Literal` | `makeEmptySequence()` | Factory method to make an empty-sequence literal
    `static <T extends Item> Literal` | `makeLiteral​(GroundedValue value)` | Factory method to create a literal as a wrapper around a Value (factory method)
    `static Literal` | `makeLiteral​(GroundedValue value, Expression origin)` | Make a literal, taking the retained static context and location information from another expression which is being simplified/optimized
    `static Literal` | `makeStringsLiteral​(java.util.List<java.lang.String> strings)` | Create a Literal containing a sequence of strings
    `Expression` | `optimize​(ExpressionVisitor visitor, ContextItemStaticInfo contextItemType)` | Optimize an expression
    `void` | `process​(Outputter output, XPathContext context)` | Process the value as an instruction, without returning any tail calls
    `Pattern` | `toPattern​(Configuration config)` | Convert this expression to an equivalent XSLT pattern
    `java.lang.String` | `toShortString()` | Produce a short string identifying the expression for use in error messages
    `java.lang.String` | `toString()` | The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath.
    `Expression` | `typeCheck​(ExpressionVisitor visitor, ContextItemStaticInfo contextInfo)` | TypeCheck an expression

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `adoptChildExpression, allowExtractingCommonSubexpressions, checkedOperands, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, dynamicError, explain, getCardinality, getConfiguration, getCost, getEvaluationMethod, getExtraProperty, getInterpretedExpression, getIntrinsicDependencies, getLocalRetainedStaticContext, getLocation, getObjectName, getPackageData, getParentExpression, getProperties, getProperty, getRetainedStaticContext, getScopingExpression, getSlotsUsed, getSpecialProperties, getStaticBaseURI, getStaticBaseURIString, getStaticType, getTracingTag, hasCompatibleStaticContext, hashCode, hasSpecialProperty, hasVariableBinding, identityHashCode, implementsStaticTypeCheck, isCallOn, isEqual, isIdentical, isInstruction, isLiftable, isMultiThreaded, isStaticPropertiesKnown, isUpdatingExpression, markTailFunctionCalls, operandList, operands, operandSparseList, optimizeChildren, prepareForStreaming, resetLocalStaticProperties, restoreParentPointers, setEvaluationMethod, setExtraProperty, setFiltered, setFlattened, setLocation, setParentExpression, setRetainedStaticContext, setRetainedStaticContextLocally, setRetainedStaticContextThoroughly, setStaticProperty, simplify, simplifyChildren, staticTypeCheck, suppressValidation, typeCheckChildren, typeError, unordered, verifyParentPointers`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.trace.Traceable

      `gatherProperties`

- - ### Constructor Detail

    - #### Literal

          protected Literal​(GroundedValue value)

      Create a literal as a wrapper around a Value
      Parameters:
        `value` - the value of this literal

  - ### Method Detail

    - #### makeStringsLiteral

          public static Literal makeStringsLiteral​(java.util.List<java.lang.String> strings)

      Create a Literal containing a sequence of strings
      Parameters:
        `strings` - the strings to be wrapped
      Returns:
        a Literal of the string sequence

    - #### getValue

          public GroundedValue getValue()

      Get the value represented by this Literal
      Returns:
        the constant value

    - #### typeCheck

          public Expression typeCheck​(ExpressionVisitor visitor,
                                      ContextItemStaticInfo contextInfo)
                               throws XPathException

      TypeCheck an expression
      Overrides:
        `typeCheck` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextInfo` - Information available statically about the context item: whether it is (possibly) absent; its static type; its streaming posture.
      Returns:
        for a Value, this always returns the value unchanged
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### optimize

          public Expression optimize​(ExpressionVisitor visitor,
                                     ContextItemStaticInfo contextItemType)
                              throws XPathException

      Optimize an expression
      Overrides:
        `optimize` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        for a Value, this always returns the value unchanged
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### getNetCost

          public int getNetCost()

      Return the estimated cost of evaluating an expression. This is a very crude measure based on the syntactic form of the expression (we have no knowledge of data values). We take the cost of evaluating a simple scalar comparison or arithmetic expression as 1 (one), and we assume that a sequence has length 5. The resulting estimates may be used, for example, to reorder the predicates in a filter expression so cheaper predicates are evaluated first.
      Overrides:
        `getNetCost` in class `Expression`
      Returns:
        the intrinsic cost of this operation, excluding the costs of evaluating the operands

    - #### getItemType

          public ItemType getItemType()

      Determine the data type of the items in the expression, if possible
      Specified by:
        `getItemType` in class `Expression`
      Returns:
        for the default implementation: AnyItemType (not known)

    - #### getStaticUType

          public UType getStaticUType​(UType contextItemType)

      Get the static type of the expression as a UType, following precisely the type inference rules defined in the XSLT 3.0 specification.
      Overrides:
        `getStaticUType` in class `Expression`
      Parameters:
        `contextItemType` - the static context item type
      Returns:
        the static item type of the expression according to the XSLT 3.0 defined rules

    - #### computeCardinality

          public int computeCardinality()

      Determine the cardinality
      Specified by:
        `computeCardinality` in class `Expression`
      Returns:
        the computed cardinality, as one of the values `StaticProperty.ALLOWS_ZERO_OR_ONE`, `StaticProperty.EXACTLY_ONE`, `StaticProperty.ALLOWS_ONE_OR_MORE`, `StaticProperty.ALLOWS_ZERO_OR_MORE`. May also return `StaticProperty.ALLOWS_ZERO` if the result is known to be an empty sequence, or `StaticProperty.ALLOWS_MANY` if if is known to return a sequence of length two or more.

    - #### computeSpecialProperties

          public int computeSpecialProperties()

      Compute the static properties of this expression (other than its type). For a Value, the only special property is `StaticProperty.NO_NODES_NEWLY_CREATED`.
      Overrides:
        `computeSpecialProperties` in class `Expression`
      Returns:
        the value `StaticProperty.NO_NODES_NEWLY_CREATED`

    - #### getIntegerBounds

          public IntegerValue[] getIntegerBounds()

      For an expression that returns an integer or a sequence of integers, get a lower and upper bound on the values of the integers that may be returned, from static analysis. The default implementation returns null, meaning "unknown" or "not applicable". Other implementations return an array of two IntegerValue objects, representing the lower and upper bounds respectively. The values UNBOUNDED_LOWER and UNBOUNDED_UPPER are used by convention to indicate that the value may be arbitrarily large. The values MAX_STRING_LENGTH and MAX_SEQUENCE_LENGTH are used to indicate values limited by the size of a string or the size of a sequence.
      Overrides:
        `getIntegerBounds` in class `Expression`
      Returns:
        the lower and upper bounds of integer values in the result, or null to indicate unknown or not applicable.

    - #### isVacuousExpression

          public boolean isVacuousExpression()

      Determine whether this is a vacuous expression as defined in the XQuery update specification
      Overrides:
        `isVacuousExpression` in class `Expression`
      Returns:
        true if this expression is vacuous

    - #### copy

          public Expression copy​(RebindingMap rebindings)

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Parameters:
        `rebindings` - variables that need to be re-bound
      Returns:
        a copy of the original literal. Note that the underlying value is not copied; the code relies on the caller treating the underlying value as immutable.

    - #### toPattern

          public Pattern toPattern​(Configuration config)
                            throws XPathException

      Convert this expression to an equivalent XSLT pattern
      Overrides:
        `toPattern` in class `Expression`
      Parameters:
        `config` - the Saxon configuration
      Returns:
        the equivalent pattern
      Throws:
        `XPathException` - if conversion is not possible

    - #### addToPathMap

          public PathMap.PathMapNodeSet addToPathMap​(PathMap pathMap,
                                                     PathMap.PathMapNodeSet pathMapNodeSet)

      Add a representation of this expression to a PathMap. The PathMap captures a map of the nodes visited by an expression in a source tree.
      Overrides:
        `addToPathMap` in class `Expression`
      Parameters:
        `pathMap` - the PathMap to which the expression should be added
        `pathMapNodeSet` - the set of nodes within the path map
      Returns:
        the pathMapNode representing the focus established by this expression, in the case where this expression is the first operand of a path expression or filter expression

    - #### getDependencies

          public final int getDependencies()

      Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as StaticProperty.VARIABLES and StaticProperty.CURRENT_NODE
      Overrides:
        `getDependencies` in class `Expression`
      Returns:
        for a Value, this always returns zero.

    - #### iterate

          public SequenceIterator iterate​(XPathContext context)
                                   throws XPathException

      Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation handles iteration for expressions that return singleton values: for non-singleton expressions, the subclass must provide its own implementation.
      Overrides:
        `iterate` in class `Expression`
      Parameters:
        `context` - supplies the context for evaluation
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### iterate

          public SequenceIterator iterate()
                                   throws XPathException

      Return an Iterator to iterate over the values of a sequence. The value of every expression can be regarded as a sequence, so this method is supported for all expressions. This default implementation handles iteration for expressions that return singleton values: for non-singleton expressions, the subclass must provide its own implementation.
      Returns:
        a SequenceIterator that can be used to iterate over the result of the expression
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### evaluateItem

          public Item evaluateItem​(XPathContext context)
                            throws XPathException

      Evaluate as a singleton item (or empty sequence). Note: this implementation returns the first item in the sequence. The method should not be used unless appropriate type-checking has been done to ensure that the value will be a singleton.
      Overrides:
        `evaluateItem` in class `Expression`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the node or atomic value that results from evaluating the expression; or null to indicate that the result is an empty sequence
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### process

          public void process​(Outputter output,
                              XPathContext context)
                       throws XPathException

      Process the value as an instruction, without returning any tail calls
      Overrides:
        `process` in class `Expression`
      Parameters:
        `output` - the destination for the result
        `context` - The dynamic context, giving access to the current node,
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### getImplementationMethod

          public int getImplementationMethod()

      Description copied from class: `Expression`
      An implementation of Expression must provide at least one of the methods evaluateItem(), iterate(), or process(). This method indicates which of these methods is provided directly. The other methods will always be available indirectly, using an implementation that relies on one of the other methods.
      Specified by:
        `getImplementationMethod` in class `Expression`
      Returns:
        the implementation method, for example `Expression.ITERATE_METHOD` or `Expression.EVALUATE_METHOD` or `Expression.PROCESS_METHOD`

    - #### evaluateAsString

          public java.lang.CharSequence evaluateAsString​(XPathContext context)
                                                  throws XPathException

      Description copied from class: `Expression`
      Evaluate an expression as a String. This function must only be called in contexts where it is known that the expression will return a single string (or where an empty sequence is to be treated as a zero-length string). Implementations should not attempt to convert the result to a string, other than converting () to "". This method is used mainly to evaluate expressions produced by compiling an attribute value template.
      Overrides:
        `evaluateAsString` in class `Expression`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the value of the expression, evaluated in the current context. The expression must return a string or (); if the value of the expression is (), this method returns "".
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### effectiveBooleanValue

          public boolean effectiveBooleanValue​(XPathContext context)
                                        throws XPathException

      Get the effective boolean value of the expression. This returns false if the value is the empty sequence, a zero-length string, a number equal to zero, or the boolean false. Otherwise it returns true.
      Overrides:
        `effectiveBooleanValue` in class `Expression`
      Parameters:
        `context` - The context in which the expression is to be evaluated
      Returns:
        the effective boolean value
      Throws:
        `XPathException` - if any dynamic error occurs evaluating the expression

    - #### evaluatePendingUpdates

          public void evaluatePendingUpdates​(XPathContext context,
                                             PendingUpdateList pul)
                                      throws XPathException

      Evaluate an updating expression, adding the results to a Pending Update List. The default implementation of this method, which is used for non-updating expressions, throws an UnsupportedOperationException. The implementation for a literal representing an empty sequence, however, is a no-op.
      Overrides:
        `evaluatePendingUpdates` in class `Expression`
      Parameters:
        `context` - the XPath dynamic evaluation context
        `pul` - the pending update list to which the results should be written
      Throws:
        `XPathException` - if evaluation fails

    - #### equals

          public boolean equals​(java.lang.Object obj)

      Determine whether two literals are equal, when considered as expressions.
      Overrides:
        `equals` in class `Expression`
      Parameters:
        `obj` - the other expression
      Returns:
        true if the two literals are equal. The test here requires (a) identity in the sense defined by XML Schema (same value in the same value space), and (b) identical type annotations. For example the literal xs:int(3) is not equal (as an expression) to xs:short(3), because the two expressions are not interchangeable.

    - #### computeHashCode

          public int computeHashCode()

      Return a hash code to support the equals() function
      Overrides:
        `computeHashCode` in class `Expression`
      Returns:
        a computed hash code

    - #### toString

          public java.lang.String toString()

      The toString() method for an expression attempts to give a representation of the expression in an XPath-like form, but there is no guarantee that the syntax will actually be true XPath. In the case of XSLT instructions, the toString() method gives an abstracted view of the syntax
      Overrides:
        `toString` in class `Expression`
      Returns:
        a representation of the expression as a string

    - #### export

          public void export​(ExpressionPresenter out)
                      throws XPathException

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `export` in interface `ExportAgent`
      Specified by:
        `export` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure
      Throws:
        `XPathException` - if the export fails, for example if an expression is found that won't work in the target environment.

    - #### exportValue

          public static void exportValue​(Sequence value,
                                         ExpressionPresenter out)
                                  throws XPathException

      Throws:
        `XPathException`

    - #### getExpressionName

          public java.lang.String getExpressionName()

      Get a name identifying the kind of expression, in terms meaningful to a user.
      Overrides:
        `getExpressionName` in class `Expression`
      Returns:
        a name identifying the kind of expression, in terms meaningful to a user. The name will always be in the form of a lexical XML QName, and should match the name used in export() output displaying the expression.

    - #### exportAtomicValue

          public static void exportAtomicValue​(AtomicValue value,
                                               ExpressionPresenter out)
                                        throws XPathException

      Throws:
        `XPathException`

    - #### toShortString

          public java.lang.String toShortString()

      Produce a short string identifying the expression for use in error messages
      Overrides:
        `toShortString` in class `Expression`
      Returns:
        a short string, sufficient to identify the expression

    - #### isAtomic

          public static boolean isAtomic​(Expression exp)

      Test whether the literal wraps an atomic value. (Note, if this method returns false, this still leaves the possibility that the literal wraps a sequence that happens to contain a single atomic value).
      Parameters:
        `exp` - an expression
      Returns:
        true if the expression is a literal and the literal wraps an AtomicValue

    - #### isEmptySequence

          public static boolean isEmptySequence​(Expression exp)

      Test whether the literal explicitly wraps an empty sequence. (Note, if this method returns false, this still leaves the possibility that the literal wraps a sequence that happens to be empty).
      Parameters:
        `exp` - an expression
      Returns:
        true if the expression is a literal and the value of the literal is an empty sequence

    - #### isConstantBoolean

          public static boolean isConstantBoolean​(Expression exp,
                                                  boolean value)

      Test if a literal represents the boolean value true
      Parameters:
        `exp` - an expression
        `value` - true or false
      Returns:
        true if the expression is a literal and the literal represents the boolean value given in the second argument

    - #### hasEffectiveBooleanValue

          public static boolean hasEffectiveBooleanValue​(Expression exp,
                                                         boolean value)

      Test if a literal has the effective boolean value true (or false)
      Parameters:
        `exp` - an expression
        `value` - true or false
      Returns:
        true if the expression is a literal and the literal represents the boolean value given in the second argument

    - #### isConstantOne

          public static boolean isConstantOne​(Expression exp)

      Test if a literal represents the integer value 1
      Parameters:
        `exp` - an expression
      Returns:
        true if the expression is a literal and the literal represents the integer value 1

    - #### isSubtreeExpression

          public boolean isSubtreeExpression()

      Determine whether the expression can be evaluated without reference to the part of the context document outside the subtree rooted at the context node.
      Overrides:
        `isSubtreeExpression` in class `Expression`
      Returns:
        true if the expression has no dependencies on the context node, or if the only dependencies on the context node are downward selections using the self, child, descendant, attribute, and namespace axes.

    - #### makeEmptySequence

          public static Literal makeEmptySequence()

      Factory method to make an empty-sequence literal
      Returns:
        a literal whose value is the empty sequence

    - #### makeLiteral

          public static <T extends Item> Literal makeLiteral​(GroundedValue value)

      Factory method to create a literal as a wrapper around a Value (factory method)
      Parameters:
        `value` - the value of this literal
      Returns:
        the Literal

    - #### makeLiteral

          public static Literal makeLiteral​(GroundedValue value,
                                            Expression origin)

      Make a literal, taking the retained static context and location information from another expression which is being simplified/optimized
      Parameters:
        `value` - the literal value
        `origin` - the expression whose context and location information is to be retained
      Returns:
        the Literal

    - #### getStreamerName

          public java.lang.String getStreamerName()

      Get the (partial) name of a class that supports streaming of this kind of expression
      Overrides:
        `getStreamerName` in class `Expression`
      Returns:
        the partial name of a class that can be instantiated to provide streaming support in Saxon-EE, or null if there is no such class